## game.py
#
#  Définit le Game Play
#
#############################################################################

import GameLogic as gl
from time import sleep
from random import uniform

scenes = gl.getSceneList()

def main():
    tempo()
    print_some()
    display_when_problem()
    set_good_level_scene()

    # Si balle sort du jeu
    ball_out()

    # Piloté par get_osc.py avec gl.rank_scene
    overlay_scene_rank()

    # Niveau 1
    if gl.level == 1:
        level_1_main()
    # Pour tous les autres niveaux
    else:
        for scn in scenes :
            if "_players" in scn.name :
                ##if gl.changement_de_niveau != 1:
                    ##gl.changement_de_niveau = 0
                positive_score()
                set_score()
                bat_block()
                other_bat_position()
                ball_position()

                if gl.debug == 2:
                    bat_move_auto()

def level_1_main():
    # Machine n'est pas géré par le serveur
    positive_score()
    set_score()
    bat_block()

    if gl.level1_rated == 0:
        automatic_bat()

    classement_level1()

def display_rank_level1():
    # Comptage du temps d'affichage seulement level 1
    if gl.rank_scene == 1 or gl.rank_scene == 2:
        gl.tempo_rank_level1 += 1
        if gl.tempo_rank_level1 > 120:
            # Fin de la scène Rank
            gl.rank_scene = 0
            gl.tempo_rank_level1 = 0
            reset_variables()

def classement_level1():
    # Classement du joueur et de la machine au niveau 1. 2 Cas
    # Cas 1: je gagne, machine perds
    if gl.level1_rated == 0:
        if gl.goal[1]["score"] == 0: # score machine
            gl.classement_level1['machine']  = 2
            gl.classement_level1[gl.my_name] = 1
            # Je ne repasserai plus par ici
            gl.level1_rated = 1
            # demande de la scèneRank
            gl.rank_scene = 1
            print("Dans niveau 1, j'ai gagné")

        # Cas 2: je perds, machine gagne
        if gl.goal[0]["score"] == 0: # mon score
            gl.classement_level1['machine']  = 1
            gl.classement_level1[gl.my_name] = 2
            # Je ne repasserai plus par ici
            gl.level1_rated = 1
            # demande de la scèneRank
            gl.rank_scene = 1
            print("Dans niveau 1, machine a gagné")
    else:
        # calcul du temps d'affichage
        display_rank_level1()

def overlay_scene_rank():
    # Ajout de la scène Rank si 1
    if gl.rank_scene == 1:
        for scn in scenes :
            if not "Rank" in scn.name:
                # 2 signifie que Rank est affiché
                gl.rank_scene = 2
                # Overlay la scène Rank
                gl.addScene("Rank")

    # Suppression de la scene Rank si 0
    if gl.rank_scene == 0:
        for scn in scenes :
            if "Rank" in scn.name:
                scn.end()
                print("Suppression de Rank")

def set_good_level_scene():
    ## Lance la scene au bon niveau si un joueur arrive ou quitte le jeu
    # La bonne scène est-elle affichée ?
    scene_ok = 0
    for scn in scenes :
        if scn.name == str(gl.level) + "_players" :
            scene_ok = 1

    # Si la scène n'est pas ok
    if scene_ok == 0:

        # Suppression de la mauvaise scène en cours, c'est forcément une scène avec "_players"
        for n in range(1, 11):
            for scn in scenes :
                if scn.name == str(n) + "_players" :
                    scn.end()
                    print("Suppression de la scène", str(n) + "_players")
        # Lancement du bon niveau
        gl.addScene(str(gl.level) + "_players")
        # Je viens de demander l'ajout de la scène, elle ne sera effective qu'à la frame suivante
        # A la frame suivante gl.changement_de_niveau repassera à 0
        #gl.changement_de_niveau = 1
        print("Ajout de la scène ", str(gl.level))

def reset_variables():
    ### Reset de variables pour repartir à zéro uniquement niveau 1
    print("Reset variables in game.py")
    gl.goal[0]["score"] = 9
    gl.goal[1]["score"] = 9
    gl.rank_display_bug = 0

    gl.tempo_globale = 0
    gl.level1_rated = 0
    gl.classement_level1 = {}
    gl.tempo_rank_level1 = 0
    # Désactivation de la scène Rank
    gl.rank_scene = 0
    # Le dictionnaire de classement des joueurs
    gl.classement = {}

    gl.block = 0

def ball_out():
    # Ball au centre si la balle sort du jeu
    if gl.ball.localPosition[0] < -15:
        gl.ball.localPosition = [0, 0, 1]
    elif gl.ball.localPosition[0] > 15:
        gl.ball.localPosition = [0, 0, 1]
    elif gl.ball.localPosition[1] < -15:
        gl.ball.localPosition = [0, 0, 1]
    elif gl.ball.localPosition[1] > 15:
        gl.ball.localPosition = [0, 0, 1]

def automatic_bat():
    ### Seulement niveau 1. Mouvement auto de la raquette machine
    for scn in scenes :
        if scn.name == "1_players":
            y = 0.7 * gl.ball.localPosition[1]
            gl.bat[1].localPosition = [9.5, y, 1]

def display_when_problem():
    ### Affichage des problèmes réseaux et du nombre de joueurs en cours
    for scn in scenes :
        # Seulement avec la scène réseau OSC
        if scn.name == "OSC":
            if gl.network_problem == 1 :
                gl.getosc["Text"] = "Problème avec le réseau, le routeur ou le serveur"
            elif gl.text_rank == 1:
                gl.getosc["Text"] = "Affichage du score"
            else:
                gl.getosc["Text"] = " Niveau: " + str(gl.level) + "\n Je suis " + gl.my_name + "\n Aide: H"

def bat_block():
    if gl.goal[gl.Iam]["score"] == 0:
        gl.block = 1
    else:
        gl.block = 0

    if gl.block == 0:
        gl.bat[gl.Iam]["activ"] = 1
    if gl.block == 1:
        gl.bat[gl.Iam]["activ"] = 0

def set_score():
    # Set score avec les scores de players_data
    # Sauf niveau 1 qui est en local
    if gl.level > 1:
        for player in range(gl.level):

            if player != gl.Iam:
                gl.goal[player]["score"] = gl.players_data[player][5]

def other_bat_position():
    ## Définir les positions des raquettes des autres joueurs, pas pour moi,
    # sauf en mode debug
    if gl.debug == 0:
        for player in range(gl.level):
            if player != gl.Iam:
                gl.bat[player].localPosition = [gl.players_data[player][3], gl.players_data[player][4], 1]

def positive_score():
    # Tous les scores doivent être >= 0
    if gl.level == 1:
        b = 2 # le niveau 1 a 2 joueurs
    else:
        b = gl.level
    for g in range(b):
        if gl.goal[g]["score"] <= 0:
            gl.goal[g]["score"] = 0

def ball_position():
    ## Placer la balle si je ne suis pas master
    # Le premier dans la liste des jouers est toujours le master, sauf la machine
    if gl.Iam != 0 :
        if gl.players_data[0][0] != 'machine':
            # Disable rigid body de la balle
            gl.ball["master"] = False
            # Set position
            gl.ball.localPosition = [gl.players_data[0][1], gl.players_data[0][2], 1]

def bat_move_auto():
    ## Déplacement auto des raquettes en mode debug
    for other in range(gl.level):
        if other != gl.Iam:
            if gl.tempo_globale < 120 :
                a = 0.05
            if gl.tempo_globale >= 120 :
                a = -0.05
            # Set amount to move
            movement = [ 0.0, a, 0.0]
            # Use local axis
            local = True
            # Move game object
            try:
                gl.bat[other].applyMovement(movement, local)
            except:
                print("Error dans game.py dans bat_move_auto()")
                pass

def print_some():
    #print('Ratio de réception = {0:.2f}'.format(gl.socket_ratio))
    if gl.tempo_globale == 0:
        print("Liste des scenes =", scenes)
        print("Liste des datas =", gl.data_for_printing)
        print('Ratio de réception = {0:.2f}'.format(gl.socket_ratio))
        print("Un ratio de 0.8 est normal, le serveur envoie moins souvent que Blender ne lit")

def tempo():
    if gl.debug == 1:
        if gl.getosc["pause"] == True:
            sleep(0.1)

    # Tempo, reset toutes les 120 frames soit 2 secondes
    gl.tempo_globale += 1
    if gl.tempo_globale > 120:
        gl.tempo_globale = 0

    # Faux score pour debugguer niveau 4, score restent bloqué à 9
    if gl.tempo_globale == 0:
        for i in range(10):
            gl.score_list[i] = uniform(0, 9)
            if gl.score_list[i] == 0:
                gl.score_list[0] = 0
                gl.score_list[1] = 0
                gl.score_list[2] = 0

cont = gl.getCurrentController()
sens = cont.sensors["Game"]
if sens.positive:
     main()
