## players_data.py
#
# A chaque frame:
#    gl.players_data   : liste de liste des datas des joueurs
#    gl.level          : le niveau, le nombre de joueurs, la scène affichée
#    gl.Iam            : ma position dans la liste
#
#  Ajout du joueur machine si un seul joueur
#  Ajout des faux joueurs pour tester
#
#############################################################################

import GameLogic as gl

''' Pour 1 joueur
 data = ['#bundle', 0.0,
        ['/fap', ',siiiiisssi','192.168.1.4', -374, 0, -950, 0, 9, 'serge', 'classement', 'serge', 0],
        ['/f', ',i', 0],
        ['/rbs', ',i', 0],
        ['/grs', ',i', 0],
        ['/qs', ',s', ''],
        ['/sr', ',i', 0]]
'''

def main():
    set_network_problem()
    for_all_players_message()
    if gl.debug == 2:
        simul_player()
    where_Iam_in_players_data()

def for_all_players_message():
    # Si il y a des datas et les bonnes
    if '/fap' in gl.data and len(gl.data) >= 2:
        # Je coupe /fap and ,ssffiissffii dans le message gl.data
        new_data = gl.data[2:]
        # La position de 'classement' est
        p = new_data.index('classement')
        # Je garde les p premiers
        new_data = new_data[:p]

        # Le nombre d'items par joueur
        num_item = 7
        # gl.data est une longue liste de x fois 11 items
        # Je coupe en sous-liste, une sous-liste = 1 joueur
        if len(new_data) % num_item == 0 : # si multiple de 11
            # je coupe en sous liste
            gl.players_data = chunks(new_data, num_item)
            # format pour impression seulement, pour ne pas avoirplus de 2 chiffres après la virgule
            gl.data_for_printing = list(gl.players_data)
            # je remets en forme la virgule
            integer2float()
        else:
            print("Il n'y a pas un multiple de 7 dans gl.data", new_data)
            gl.players_data = [['10.0.0.1', 3, 3, 5, 5, 12, 'toto']]

    # Le classement level 1 est fait dans game, le serveur ne sert à rien
    if gl.level > 1:
        # Je récupère le classement qui commence après le p ème, soit p+3 dans gl.data
        raw_classement = gl.data[p+3:]

        # il y a n joueurs classés
        n = int(len(raw_classement)/2)
        for i in range(n):
            gl.classement[raw_classement[2*i]] = raw_classement[2*i+1]

        # Bug machine est parfois dans la liste
        if "machine" in gl.classement:
            del gl.classement["machine"]

    # Autres niveaux
    gl.level = len(gl.players_data)
    # Même si il n'y a pas de data, on est au niveau 0
    if gl.level == 0:
        gl.level = 1

def integer2float():
    '''Remplacement des entiers par des float pour ball loc et bat loc
    dans gl.players_data'''
    for i in range(len(gl.players_data)):
        for m in [1,2,3,4]:
            gl.players_data[i][m] = gl.players_data[i][m]/100

def where_Iam_in_players_data():
    # gl.Iam est ma position dans la liste
    gl.Iam = 0
    if gl.players_data != []:
        for i in range(len(gl.players_data)):
            if gl.players_data[i][6] == gl.my_name:
                gl.Iam = i

def simul_player():
    ## Simulation de joueurs
    # max = 8, min = 0
    add = gl.getosc["add"]
    if add > 9 : add = 9
    if add < 0 : add = 0
    for n in range(add):
        # Fictive players are added at data
        gl.players_data.append(gl.simul[n])
        gl.level = n + 2

def set_network_problem():
    if not '/fap' in gl.data :
        gl.network_problem = 1
    else:
        gl.network_problem = 0

def chunks(list_to_cut, n):
    # Cut a list in a list of n lists
    return [list_to_cut[i:i+n] for i in range(0, len(list_to_cut), n)]

cont = gl.getCurrentController()
sens = cont.sensors["Game"]
if sens.positive:
    main()
