## rank_display.py
#
#  Ce script est lancé avec la scène Rank
#
#  Crée et applique le texte du classement à chaque frame
#
#############################################################################

import GameLogic as gl

# Get scenes
scenes = gl.getSceneList()

# avec
# gl.classement = {'toto': 3, 'labomedia': 2, 'gddgsg': 1}
# on doit avoir
# 1.    gddgsg + "\n\n"
# 2 .   labomedia  + "\n\n"
# 3 .   toto + "\n\n"

def main():
    create_text()
    apply_text()

def create_text():
    # Pour tous les niveaux, y compris le 1
    if gl.level == 1:
        level_corrected = 2 # 2 joueurs même au niveau 1
        gl.classement = gl.classement_level1
    else :
        level_corrected = gl.level

    #debug
    #gl.classement = {'toto': 3, 'labomedia': 1, 'gddgsg': 2}
    #level_corrected = 3

    # Création d'une liste avec 1 élément = 1 joueur
    text_list = [0] * level_corrected # exemple c=3 donne [0, 0, 0]

    # Si value=0, le joueur est en cours et non classé,
    # le texte sera vide, affichage du rang seulement
    a = 0
    for key, value in gl.classement.items():
        if value == 0:
            # \n\n crée les sauts de ligne
            text_list[a] = str(a+1) + ".  \n\n"
            a += 1

    # Si value!=0, le joueur est classé,
    b = 0
    for key, value in gl.classement.items():
        if value > 0:
            # \n\n crée les sauts de ligne
            text_list[value - 1] = str(value) + " .   " + str(key) + "\n\n"
            b += 1

    # String de l'ensemble du texte à afficher
    gl.text = ""
    # debug
    #text_list = [" 1.    gddgsg \n\n", " 2 .   labomedia \n\n", " 3 .   toto \n\n"]
    for c in range(level_corrected):
        gl.text = gl.text + str(text_list[c])
    # debug
    #gl.text = " 1.    gddgsg \n\n 2 .   labomedia \n\n 3 .   toto \n\n"

def apply_text():
    for scn in scenes:
        # Seulement si Rank en cours
        if scn.name == "Rank":
            # Récupération de l'objet Rank_display et sa prop Text
            for obj in scn.objects:
                if str(obj) == "Rank_display":
                    rank_obj = obj
                    rank_obj["Text"] = gl.text

cont = gl.getCurrentController()
sens = cont.sensors["rank_display"]
if sens.positive:
    main()
