## send_data.py
#
#  Lancé  à chaque frame pour envoyer les messages OSC au serveur.
#
#############################################################################

import GameLogic as gl
from OSC3.OSC import OSCClient, OSCMessage

# Get all scenes
scenes = gl.getSceneList()



if not gl.client_connected :
    if gl.ip_server != None:
        #addr_out = gl.ip_multicast, gl.port_out
        addr_out = gl.ip_server, gl.port_out
        gl.client_connected = True
        gl.clt = OSCClient()
        gl.clt.connect(addr_out)
        print("Client connecté")

def main():
    if gl.client_connected:
        message_a_chaque_frame()
        message_particulier()

def message_a_chaque_frame():
    # Valeurs par défaut à envoyer
    score = 11
    bat_loc = [0, 0]
    ball_loc = [0, 0]

    # Valeurs actualisées à envoyer
    for scn in scenes:
        if "_players" in scn.name:

            # Ball:
            ball_loc = [float2integer(gl.ball.localPosition[0]), float2integer(gl.ball.localPosition[1])]

            # Ma position de Bat et mon score
            score = gl.goal[gl.Iam]["score"]
            #score = gl.score_list[gl.Iam]
            bat_loc = [float2integer(gl.bat[gl.Iam].localPosition[0]), float2integer(gl.bat[gl.Iam].localPosition[1])]

    if score == 11:
        gl.getosc["Text"] = "Problème avec le score dans send_data.py"

    # Création du message complet
    # old = ('/player_data', ['/ball', ball_loc, '/bat', bat_loc, '/score', score,'/name', gl.my_name])
    send_message('/d',       [         ball_loc        , bat_loc          , score,         gl.my_name])

def float2integer(f):
    '''Transforme un réel en entier, int(réel multiplié par 100)'''
    return int(100*f)

def message_particulier():
    ## Message particulier
    # Quit
    if gl.sendosc["quit"]:
        # old = ('/quit', 1)
        send_message('/q', 1)
        print('OSC message /quit sended')

    # Reset
    if gl.sendosc["reset_ball"] == 1:
        gl.sendosc["reset_ball"] = 0
        # old = ('/reset_ball', 1)
        send_message('/rb', 1)
        print('OSC message /reset sended')

    # New Game
    if gl.sendosc["reset_game"] == 1:
        gl.sendosc["reset_game"] = 0
        # old = ('/reset_game', 1)
        send_message('/rg', 1)
        print('OSC message /reset_game sended')

def send_message(title, message):
    m = OSCMessage(title)
    m.append(message)

    gl.clt.send(m)

cont = gl.getCurrentController()
sens = cont.sensors["Send"]
if sens.positive:
     main()
